package hanging;

import org.junit.Test;
import org.kie.api.KieServices;
import org.kie.api.builder.KieFileSystem;
import org.kie.api.builder.model.KieBaseModel;
import org.kie.api.builder.model.KieModuleModel;
import org.kie.api.conf.EventProcessingOption;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.conf.ClockTypeOption;
import org.kie.internal.io.ResourceFactory;

import java.io.IOException;

/**
 * Created by xinguo on 7/10/16.
 */
public class HangingTest {

    String queryRuleTest1 = "import hanging.CAA \n"+
            "import hanging.DPAA \n"+
            "query \"classAssertionQuery\" (individual)\n" +
                    "   CAA(i==individual)\n" +
                    " end" +

                    "\nrule \"Break Query\"\n" +
                    " no-loop" +
                    " when" +
                    " DPAA($subject:s, pid==\"core:age\")" +
                    " then" +
                    " System.out.println(drools.getKieRuntime().getQueryResults(\"classAssertionQuery\", $subject));"+
                    " end";

    @Test
    public void testRepro() throws IOException {

        KieServices kieServices = KieServices.Factory.get();
        KieFileSystem kieFileSystem = kieServices.newKieFileSystem();
        KieModuleModel kieModuleModel = kieServices.newKieModuleModel();

        KieBaseModel baseModel = kieModuleModel.newKieBaseModel("defaultBase")
                .setDefault(true)
                .setEventProcessingMode(EventProcessingOption.STREAM);

        baseModel.newKieSessionModel("defaultKSession").setDefault(true).setClockType(ClockTypeOption.get("pseudo"));

        kieFileSystem.writeKModuleXML(kieModuleModel.toXML());

        kieFileSystem.write(ResourceFactory.newByteArrayResource(queryRuleTest1.getBytes())
                .setTargetPath("org/drools/compiler/integrationtests/test.drl"));

        kieServices.newKieBuilder(kieFileSystem).buildAll();

        KieContainer kieContainer = kieServices.newKieContainer(kieServices.getRepository().getDefaultReleaseId());
        KieSession session = kieContainer.newKieSession();

        session.insert(new CAA("core:sample", "sample01"));
        session.insert(new DPAA("sample01", "core:age", 10));

        session.fireAllRules();

    }
}
